#pragma once

#include "StdAfx.h"
#include "Common.h"
#include "Util.h"

using namespace System;

namespace DWriteWarpper {
	public enum class DReadingDirection
	{
		LeftToRight,
		RightToLeft,
	};
	public enum class DWordWrapping
	{
		NoWrapping,
		Wrapping,
	};
	public ref class DTextFormat
	{
	private:
		IDWriteTextFormat* pTextFormat_;
		bool disposed;
	internal:
		DTextFormat(IDWriteTextFormat* pTextFormat);

		property IDWriteTextFormat* dwTextFormat
		{
			IDWriteTextFormat* get();
		}

	public:
		property DReadingDirection ReadingDirection
		{
			DReadingDirection get();
			void set(DReadingDirection value);
		}
		property DWordWrapping WordWrapping
		{
			DWordWrapping get();
			void set(DWordWrapping value);
		}

		property float TabWidth
		{
			float get();
			void set(float value);
		}

		~DTextFormat(void);

		!DTextFormat();
	};
}
